;; CRESY-II: CREativity from a SYstems Perspective
;; Programmed by C. Kahl (and helpers credited locally in the code)
;; This is STILL NOT a demonstration in parsimonious programming! ;)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GLOBALS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

globals [rgbSpace rgbSpaceDom hCAll hX.Y rel crea hCx hC1 hC2 hC3 hX hY hXY cond evalStrategy] ; Constituting and output varialbes.

; Three entities in the system: Creators, evaluators and the domain.
breed [creators creator]
breed [evaluators evaluator]
breed [domain]

creators-own [cR cG cB] ; Creators' memory variables.
evaluators-own [eMem] ; Evaluators' memory.
domain-own [evalList cScoreList justRated justRatedTable] ; Records of evaluations and calculated creativity scores over the entire simulation as well as for the current step.

; Creators & evaluators communicate indirectly via patches, which is why these entities have a lot of variables. 
patches-own [pR pG pB pDom hue cScore whosNext madeBy PcScoreList justMade toDo currentEvals] 



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SETUP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to setup
  ca
  
  
;GLOBALS;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
 
  ; List w/ all possible red values (8-bit).
  let r256 [ 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25               
          26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48
          49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71
          72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94
          95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 
          114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 
          132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 
          150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 
          168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 
          186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 
          204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 
          222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 
          240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 ] 
   let g256 (r256) 
   let b256 (r256)

   ; List w/ transformed red values (8-bit [0-255] => 2-bit [0-4], 3-bit [0-7], or 4-bit [0-15] => according to domSize; see Interface). 
   ; This has technical reasons. My computers do not run unless I reduce the color space => soft-core nerd equipment!
   ; On a substantial level, this means evaluators only see/recognize/categorize final products, not their individual parts (r,g,b).
   let r (map [reduce-space ?] r256) 
   set r remove-duplicates r 
   
   let g (r) 
   let b (r)

   set rgbSpace [] 
   ; THANKS to James Steiner from Netlogo Users' Group for the next 7 lines of code! :)
   ; I would never have come up with this...
     foreach r 
       [ let #r ? 
         foreach g
           [ let #g ?
             foreach b
               [ let #b ?
                 ; rgbSpace is a list of nested lists = all rgb "patchworks" / potential product space. 
                 set rgbSpace fput (list #r #g #b) rgbSpace ]]]  
                                                                
    
    let z []
    foreach rgbSpace [set z lput (replace-with-position ?) z]
    set rgbSpaceDom []
      foreach z
        [ let #z ? set rgbSpaceDom lput (list #z) rgbSpaceDom]
        
    ; Global variable rgbSpaceDom is now a list of #domSize nested lists, the latter containing 2 items: 
    ; 1) Position in rgbSpace 2) frequency counter.
    ; rgbSpaceDom theoretically represents the domain's "space" or realm. In the CRESY models, it is limited, endless, and known to the observer.
    ; This is not completely realistic, but an alternative which keeps us working (= our computers running) at this point. => Start out small(er), then grow complexity.
    set rgbSpaceDom (map [add-item ?] rgbSpaceDom)                                                  

;PATCHES;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   ask patches [
     set pR (set-pcolor r256 predefine-r) 
     set pG (set-pcolor g256 predefine-g) 
     set pB (set-pcolor b256 predefine-b) 
     set pcolor (rgb pR pG pB)
     set pDom (map [reduce-space ?] pcolor); pDom is rgb list with reduced values according to domSize (see Interface).
     set plabel (replace-with-position pDom)
     set hue (set-hue-preucil pR pG pB)
     set plabel-color (round (approximate-rgb pR pG pB)) ; This is set just for checking / debugging purposes.
     set madeBy "Env" ; Until a creator has painted a patch(work), the patch is made by the ENVironment ("Env"), i.e. it is given in the world.
     set cScore -1 ; Until a patchwork has been evaluated, it has the creativity score (cScore) -1 by default. This is beyond the realm of the range of possible cScores (namely 0-1).
     set justMade false
     set currentEvals []
     ] 

;CREATORS;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ask n-of number-creators patches [
    sprout-creators 1 
      [face one-of neighbors4
       set size 3
       set shape "person"
       ; The next 3 lists (cR, cG, cB) represent creators memories for red, blue and green values.
       ; Each value (0-255) is represented by a "nested" list in the overall list. 
       ; Items 0 (left-hand items) in every nested list represent value (0-255).
       ; Items 1 (right-hand items) in every nested list represent a "frequency counter". 
       ; All creators start with null in their memories.
      set cR [ [0 0] [1 0] [2 0] [3 0] [4 0] [5 0] [6 0] [7 0] [8 0] [9 0] [10 0] [11 0] [12 0] [13 0] [14 0] [15 0] [16 0]
               [17 0] [18 0] [19 0] [20 0] [21 0] [22 0] [23 0] [24 0] [25 0] [26 0] [27 0] [28 0] [29 0] [30 0] [31 0] [32 0]
               [33 0] [34 0] [35 0] [36 0] [37 0] [38 0] [39 0] [40 0] [41 0] [42 0] [43 0] [44 0] [45 0] [46 0] [47 0] [48 0]
               [49 0] [50 0] [51 0] [52 0] [53 0] [54 0] [55 0] [56 0] [57 0] [58 0] [59 0] [60 0] [61 0] [62 0] [63 0] [64 0]
               [65 0] [66 0] [67 0] [68 0] [69 0] [70 0] [71 0] [72 0] [73 0] [74 0] [75 0] [76 0] [77 0] [78 0] [79 0] [80 0] 
               [81 0] [82 0] [83 0] [84 0] [85 0] [86 0] [87 0] [88 0] [89 0] [90 0] [91 0] [92 0] [93 0] [94 0] [95 0] [96 0] 
               [97 0] [98 0] [99 0] [100 0] [101 0] [102 0] [103 0] [104 0] [105 0] [106 0] [107 0] [108 0] [109 0] [110 0] 
               [111 0] [112 0] [113 0] [114 0] [115 0] [116 0] [117 0] [118 0] [119 0] [120 0] [121 0] [122 0] [123 0] [124 0]
               [125 0] [126 0] [127 0] [128 0] [129 0] [130 0] [131 0] [132 0] [133 0] [134 0] [135 0] [136 0] [137 0] [138 0] 
               [139 0] [140 0] [141 0] [142 0] [143 0] [144 0] [145 0] [146 0] [147 0] [148 0] [149 0] [150 0] [151 0] [152 0]
               [153 0] [154 0] [155 0] [156 0] [157 0] [158 0] [159 0] [160 0] [161 0] [162 0] [163 0] [164 0] [165 0] [166 0]
               [167 0] [168 0] [169 0] [170 0] [171 0] [172 0] [173 0] [174 0] [175 0] [176 0] [177 0] [178 0] [179 0] [180 0] 
               [181 0] [182 0] [183 0] [184 0] [185 0] [186 0] [187 0] [188 0] [189 0] [190 0] [191 0] [192 0] [193 0] [194 0]
               [195 0] [196 0] [197 0] [198 0] [199 0] [200 0] [201 0] [202 0] [203 0] [204 0] [205 0] [206 0] [207 0] [208 0]
               [209 0] [210 0] [211 0] [212 0] [213 0] [214 0] [215 0] [216 0] [217 0] [218 0] [219 0] [220 0] [221 0] [222 0]
               [223 0] [224 0] [225 0] [226 0] [227 0] [228 0] [229 0] [230 0] [231 0] [232 0] [233 0] [234 0] [235 0] [236 0]
               [237 0] [238 0] [239 0] [240 0] [241 0] [242 0] [243 0] [244 0] [245 0] [246 0] [247 0] [248 0] [249 0] [250 0]
               [251 0] [252 0] [253 0] [254 0] [255 0] ]
      set cG (cR)
      set cB (cR) ]]
             
      ifelse number-creators != Cx + C1 + C2 + C3; Input plausibility check (see Interface).
          [output-print "Check number-creators & input creator types."]
          [ask n-of Cx creators [set label "Cx"]
           ask n-of C1 creators with [label = ""] [set label "C1"] 
           ask n-of C2 creators with [label = ""] [set label "C2"]  
           ask n-of C3 creators with [label = ""] [set label "C3"]]

      ask creators with [label = "Cx"] [set color 9.9]
      ask creators with [label = "C1"] [set color 7]
      ask creators with [label = "C2"] [set color 4]
      ask creators with [label = "C3"] [set color 0]

;EVALUATORS;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

if use-evaluators? = true [
      ask n-of number-evaluators patches [
        sprout-evaluators 1 
        [face one-of neighbors4
         set size 3
         set shape "person service"
         set color white
         ; Each evaluator has a memory (eMem). It is a list of two-item nested lists. 
         ; Item 0 = domSize value (0-domSize) for domSize-reduced rgb color space.  
         ; Item 1 = frequency counter. Evaluator memories are updated every step in obtain-info.
         set eMem (rgbSpaceDom) 
        ]
      ]
      
      ifelse number-evaluators != En + Ea + Ena; Input plausibility check (see Interface).
          [output-print "Check number-evaluators & input evaluator types."]
          [ask n-of En evaluators [set label "En"]
           ask n-of Ea evaluators with [label = ""] [set label "Ea"] 
           ask n-of Ena evaluators with [label = ""] [set label "Ena"]  
          ]
]
      
;DOMAIN;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
     create-domain 1
     ask domain [set size 0 ; The domain is an invisible turtle which collects domain / output information.
                 set evalList (rgbSpaceDom)
                 let x 0
                 set evalList (map [redo ? x] evalList) ; evalList is a list of domSize nested lists containing the evaluators'judgements (0 = not creative; 1 = creative).
                 
                 
                 
                 set cScoreList (evalList) ; cScoreList is a list with domSize items. Each item is the current creativity score (cScore) for a particular patchwork (the position or index of the list item IS the patchwork category!). 
                 
              
                 
                 set x 1
                 set cScoreList (map [redo ? x] cScoreList)
           
                 set justRated []
                 set justRatedTable []
     ] 
     end 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SETUP PROCEDURES
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Sets up patch colors in world (Interface tab) w/ r256, g256, b256 (=colorList) & predefine-r,-g,-b (=predefine).
to-report set-pcolor [colorList predefine] 
  let l (colorList)
  if-else predefine = 1
    [set l [0]]
    [while [length l > (predefine)]
      [set l but-last l]] 
   report (one-of l) ; Sets color value to one of reduced l (= length predefine).
end

; Transforms value from 8-bit dimension/space to value from 2-, 3- or 4-bit dimension/space.
to-report reduce-space [x] 
   if domSize = 64 [ ; 6-bit domain / product space
    set x ((x * 4) / 256)]
   if domSize = 512 [ ; 9-bit domain / product space
    set x ((x * 8) / 256)]
   if domSize = 4096 [ ; 12-bit domain / product space
    set x ((x * 16) / 256)]
   report floor x ; "floor" reports the largest integer less than or equal to x. 
end

; Adds new item (e.g. frequency counter) to list.
to-report add-item [nestedList] 
  set nestedList lput (0) nestedList 
  report nestedList
end

; Exchanges observation pDom with observation's position in rgbSpace.
to-report replace-with-position [x] 
  report (position x rgbSpace) 
end

; Designates a patchwork's color as warm or cool according to Preucil's color circle.
to-report set-hue-preucil [R G B]
 let h []
 if R >= G [if G >= B [set h "warm"]]
 
 if G > R [if R >= B [
     let hp (60 * (2 - ((R - B) / (G - B))))
     ifelse hp < 135 [set h "warm"] [set h "cool"]]]
  
 if G >= B [if B > R [set h "cool"]]
 if B > G [if G > R[set h "cool"]]
 
 if B > R [if R >= G [
     let hp (60 * (4 + ((R - G) / (B - G))))
     ifelse hp < 315 [set h "cool"][set h "warm"]]]
 
 if R >= B [if B > G [set h "warm"]]
 
 report h 
end

; Transforms filled nested list (in larger list) to an empty nested list.
to-report redo [smallList x]
  ifelse x = 0
    [set smallList []]
    [set smallList -1]
  report smallList
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to go
  
  obtain-info
 
  make-patchwork 
 
  rate-patchwork 

  move
 
  forget-some-info
  
  tick
  
  update-domain
  
  if tickstop? = true [if ticks > tickstop [stop]] 
  
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GO PROCEDURES
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;
; Creators and evaluators are influeced by their domain. They "interact" with it by selectively peceiving its information.
; Selective perception means creators and evaluators only gain info from their immediate surroundings (neighbors 4 or 8 alias info-rate in the Interface Tab). 
to obtain-info
  ; Creators interact with the domain by asking neighboring patches for thier r, g, and b values.
  ask creators [
    let rList []
    let gList []
    let bList []
    ask (ask-whom info-rate) [
      set rList fput (pR) rList 
      set gList fput (pG) gList 
      set bList fput (pB) bList]         
    set cR map [update ? rList] cR ; For every newly "seen" red value, 1 is added to the value's freqeuncy counter =>
    set cG map [update ? gList] cG ; See "to-report update" below for how this code works. 
    set cB map [update ? bList] cB 
  ]
  
  ; Evaluators interact with the domain by asking neighboring patches for their plabel values; they indicate a patchwork's domSize category.
  ; Remember evaluators see only final products (= domSize category or plabel), not the products' parts (r, g, b values).
  if use-evaluators? = true [
  ask evaluators [
    let eList []
    ask (ask-whom info-rate) [
      set eList lput (plabel) eList]
    set eMem map [update ? eList] eMem
  ]
  ]
  
end       
  
  to-report ask-whom [x] 
    ifelse x = "n4"
      [report neighbors4]
      [report neighbors]
  end
  
  
  ; THANKS to Seth Tisue (Netlogo Users' Group) for developing this procedure! :)
  ; It adds 1 to the frequency counter of every value "seen" (at the neighbors').
  to-report update [pair items] 
    let n item 0 pair           
    report list n (item 1 pair + length filter [? = n] items)
  end
;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;
; This is when creators use their heads as "combinatorial hoppers" to produce a new patchwork.
; They select one r, one g and one b value from their memory lists (cR, cG, cB) and combine them to one "patchwork", i.e. a color they paint on a nearby patch.
to make-patchwork
  
  
  
 
  ask creators [; A lot of local variables are used in this procedure.
    let r [] 
    let g [] 
    let b [] 
    
    let copy-cR (cR) ; Uses copy of cR to make sure cR is not mistakenly altered.
    let copy-cG (cG)
    let copy-cB (cB) 
    
    let sumFq-cR (sum map [item 1 ?] copy-cR) ; Adds up all the red values already seen.
    let sumFq-cG (sum map [item 1 ?] copy-cG) 
    let sumFq-cB (sum map [item 1 ?] copy-cB) 
  
    let relFq-cR (map [item 1 ? / sumFq-cR] copy-cR) ; Makes new list only of relative frequencies.
    let relFq-cG (map [item 1 ? / sumFq-cG] copy-cG) 
    let relFq-cB (map [item 1 ? / sumFq-cB] copy-cB) 
   
    ; See to-report replace procedure below. Makes new (inverse) list from relFq-... according to imagination (see Interface Tab).
    let inverse-cR (map [replace ? relFq-cR] relFq-cR) 
    let inverse-cG (map [replace ? relFq-cG] relFq-cG) 
    let inverse-cB (map [replace ? relFq-cB] relFq-cB) 
     
    let randomValue ["r" "g" "b"] 

    if label = "Cx" [ 
      ; This creator type makes - with a high probability - the most common patchwork it knows (highly "unoriginal" or "conventional" creative behavior).
      set r (select-value copy-cR relFq-cR) ; See to-report procedure select-value below.
      set g (select-value copy-cG relFq-cG) 
      set b (select-value copy-cB relFq-cB)
    ]
    
    if label = "C1" [ 
      ; This creator type is "original" (uses inverse lists) in one dimension (randomly r, g, or b) and 
      ; "conventional" (uses relFq lists) in the two others.
      ; It is therefore somewhat more "original" or less "conventional" than Cx.
      ; Randomly selects the r, g or b dimension to be original in. Both other dimensions are selected conventionally.
      let x (one-of randomValue)  
      if x = "r" ; r is selected from the inverse list, g & b from the relFq lists.
        [set r (select-value copy-cR inverse-cR) ; See to-report procedure select-value below.
         set g (select-value copy-cG relFq-cG) 
         set b (select-value copy-cB relFq-cB)
        ]       
      if x = "g" ; g is selected from the inverse list, r & b from the relFq lists.
        [set r (select-value copy-cR relFq-cR) ; See to-report procedure select-value below.
         set g (select-value copy-cG inverse-cG)
         set b (select-value copy-cB relFq-cB)
        ]
      if x = "b" ; b is selected from the inverse list, r & g relFq lists.
        [set r (select-value copy-cR relFq-cR) ; See to-report procedure select-value below.
         set g (select-value copy-cG relFq-cG) 
         set b (select-value copy-cB inverse-cB)
        ]   
    ]
    
    if label = "C2" [ 
      ; This creator is "original" (uses inverse lists) in two dimensions (r, g and/or b) and 
      ; conventional (uses relFq list) in one.
      ; It is therefore more "original" and more "unconventional" than C1 and Cx.
      let x (one-of randomValue)
       if x = "r" ; r is selected from relFq list, g & b from inverse lists.
        [set r (select-value copy-cR relFq-cR) ; See to-report procedure [1] select-value below.
         set g (select-value copy-cG inverse-cG) 
         set b (select-value copy-cB inverse-cB) 
        ]       
      if x = "g" ; g is selected conventionally, r & b originally.
        [set r (select-value copy-cR inverse-cR) ; See to-report procedure [1] select-value below.
         set g (select-value copy-cG relFq-cG) 
         set b (select-value copy-cB inverse-cB) 
        ]
      if x = "b" ; b is selected conventionally, r & g originally.
        [set r (select-value copy-cR inverse-cR) ; See to-report procedure [1] select-frequent-value below.
         set g (select-value copy-cG inverse-cG) 
         set b (select-value copy-cB relFq-cB) 
        ]   
    ]
    
    if label = "C3" [ ; This creator type is original in all three dimensions (r, g, and b) it selects.
      set r (select-value copy-cR inverse-cR) ; See to-report procedure [1] select-value below.
      set g (select-value copy-cG inverse-cG) 
      set b (select-value copy-cB inverse-cB) 
    ]
  
    let mb (label) ; Sets local variable mb to creator's label. mb is then used to set patches' variable madeBy.
    
    ; Each creator needs to select a patch to "paint" its freshly combined color on. 
    ; In CRESY-II, this is done by asking all free spaces (neighbors not just made by another creator) for their current cScores. 
    ; The creator then acknowledges the worst creativity score (cScore) in this group,
    ; and then randomly selects a space in that group with that score to paint over.
    ; It could be that the agentset freeSpaces is made up of just one patch, but that would only occur when there are lots of creators in the world.
    let freeSpaces (neighbors with [justMade = false])
    let scoreList []
    ask freeSpaces [set scorelist fput cScore scoreList]
    set scoreList (sort scoreList)
    let score (item 0 scoreList)
    ask one-of freeSpaces with [cScore = score]
    ; The selected patch's variables are updated now:
     [set pR (r) ; Selected patch saves new red value (= new info).
      set pG (g) 
      set pB (b)   
      set pcolor (rgb pR pG pB)   
      set pDom (map [reduce-space ?] pcolor) 
      set plabel (replace-with-position pDom)
      set hue (set-hue-preucil pR pG pB)
      set madeBy (mb)
      if ticks > 0 [
        if use-evaluators? = true [
          set justMade true
          ;let k []
;          ask domain [set k (cScoreList)]
;          set PcScoreList (k) ; Patches receive current domain evaluation list, meaning they have list of cScores for patchwork (= domSize) categories.
;          let x (plabel)
;          let y (item x PcScoreList)
;          set cScore (y) 
       
        ]
      ]
      
   ]  
]

end

; [1]
to-report select-value [a b] ; Thanks to Nick Bennett from the Netlogo Users' Group for this procedure. :)
  ; It works via inverse cumulative distribution sampling:
  let selector (random-float sum b) ; Generates continuous, uniformly distributed pseudo-random value on the interval [0, sum weights (b)].
                                    ; The expression "random-float sum b" will never return a value greater than or equal to "sum b",
                                    ; so the running-sum (see below) is guaranteed to exceed selector eventually.
  let running-sum 0 ; Cumulates weights (b); see below.
  (foreach a b [
    set running-sum (running-sum + ?2) ; Iterates over the lists a and b, keeping track of cumulative b,
    if  (running-sum > selector) ; and finding the value at which the cumulative b first exceeds selector.
      [report item 0 ?1]
  ])
end

; [2] 
to-report replace [x listX] ; Makes inverse of relFq-..., and incorporates the variable imagination (see Interface Tab) for "unknown" values.
  ifelse x = 0
    [let y (filter [? = 0] listX) ; Makes new list y from listX with only items = 0. 
     report (imagination / (length y))] ; Reports new value for listX items with value = 0, namely new value =  imagination / length y.
    [let q (filter [? > 0] listX) ; Make a new list q from listX with only items > 0 (items < 0 should not be in there at all!).
     ifelse (length q) = 1
       [report (1 - imagination)] ; If there's only one item in list q, x is reported back as (1 - imagination).
       [set x (1 - x) ; Relative "seldomness" or "originality" calculated by (1 - (relative frequency => x)). 
        set x (x / ((length q) - 1)) ; Take new x (relative seldomness) and divide by (n - 1) => ((length of list q) - 1). => "normed" x.
        report (x * (1 - imagination))] ; Reports back "normed" x multiplied by (1 - imagination). 
    ]
end
;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;
to rate-patchwork
  
  if use-evaluators? = true [
    ask evaluators [  
     
      let w (who)
      ask patch-here [set whosNext w] ; Makes sure evaluator returns to patch-here after rating newly made patchworks.                       
      
      ; Evaluator makes a toDo list of patchworks to rate; only those just made by creators in this tick.
      ; => Ensures that reliability (calculated in update-domain) is based only on current judgements.
      ask patches with [justMade = true] [set toDo true] 
      while [any? patches with [toDo = true]] [
        
        move-to one-of patches with [toDo = true]
        
        let n []
        let a []
        let k [] 
       
        if label != "Ea" [
          let x []
          ask patch-here [set x (plabel)]     
          let y []
          set y (item 1 (item x eMem))   
          let z []
          foreach eMem [set z lput (feed-fq ?) z] 
          set z (sum z)
          set y (y / z) ; Local variable y is now = relative frequency of current domSize value frequency in evaluator's memory.   
          ifelse y <= novelty-stringency ; Relative fq compared with stringency (see Interface slider).
            [set n 1] ; 1 = novel
            [set n 0] ; 0 = not novel       
        ]
        
        if label != "En" [ ; All but Evaluators En do the following:
          let statusHue []
          ask patch-here [set statusHue (hue)] ; Patch's hue value ("warm" or "cool") is set to local variable statusHue.
          let countContext [] 
          ; Count number of patches with same hue value. Evaluators have an imperfect view; they only see 6 of 8 neighbors.
          ; This is to make sure appropriateness evaluations vary. Otherwise all evaluators would always give the same evaluations,
          ; because appropriateness-stringency is set to the same value for all evaluators. In any case evaluators do look at the
          ; majority of surrounding patchworks to make their decision.
          ask n-of 6 neighbors [if hue = statusHue [set countContext lput 1 countContext]]                                                                  
          let comparison ((sum countContext) / 6) ; Calculate relative frequency: Number of 6 neighbors with same hue value divided by total number of neighbors.
          ifelse comparison >= appropriateness-stringency [set a 1] [set a 0] ; If relative frequency is equal or larger than appropriateness-stringency, then 1 = appropriate ; 0 = not appropriate.     
        ]

       if label = "En" [set k (n)]
       if label = "Ea" [set k (a)] 
       if label = "Ena"[
         let na (n + a) ; For Ena: Only if novelty AND appropriateness are = 1 is the patchwork considered creative.
         ifelse na = 2
           [set k 1 ] ; 1 = creative
           [set k 0 ] ; 0 = not creative
       ]
      
      let p []  
      ask patch-here [set p (plabel) set toDo false set currentEvals fput (k) currentEvals ] ; Currently judged patch updated.
      
      ask domain [ ; Current judgement added to domain.
        set evalList replace-item p evalList (fput (k) item p evalList)
        
      ]
                                   
] ; while...
      
  move-to one-of patches with [whosNext = w] ; So evaluator goes back to where it was before rating patchworks.
  
] ; ask evaluators...

    

  ask patches [set whosNext -1] ; Resets whosNext.
] ; if use-evaluators?...
end
 
 to-report feed-fq [xList] ; Extracts all frequency counters (items 1) from evaluator's memory eMem.
   let a (item 1 xList)
   report a
 end
 
 to-report do-score [xList]
   ifelse empty? xList
   [set xList -1]
   [let x (filter [? > 0] xList)
    set xList (length x / length xList)
    set xList (precision xList 3)]
   report xList
 end
;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;
to move 

if movement = "any8" [
;; THANKS to U. Wilensky's "One Turtle Per Patch" Code Example (see Netlogo's Models Library) for this procedure. :)
;; TURTLE STRATEGY #2:
;; Check neighboring patches to see if any are empty.  If any are
;; empty, pick a random empty one and move onto its center. Else stay put.
  ask turtles [
    let empty-patches neighbors with [not any? turtles-here]
    if any? empty-patches
      [let target one-of empty-patches
       face target
       move-to target]]]

if movement = "allButBehind7" [
;; A turtle goes to any empty neighboring patch BUT the one directly behind itself. If no patch is empty, the turtle stays put.
 ask turtles [
   let whosNotNext who
   ask patch-left-and-ahead 180 1 [set whosNext whosNotNext]
   let patch-destinations neighbors with [whosNext != whosNotNext]  
   let target one-of patch-destinations with [not any? turtles-here]
   if target != nobody [
     face target
     move-to target]]
 ask patches [set whosNext -1]]

if movement = "ahead3" [
;; A turtle goes to one of the three empty patches ahead of it. If no patch is empty, the turtle stays put.
   ask turtles [
   let x who
   ask patch-ahead 1 [set whosNext x]
   ask patch-left-and-ahead 45 1 [set whosNext x]
   ask patch-right-and-ahead 45 1 [set whosNext x]
   let patch-destinations neighbors with [whosNext = x]
   let target one-of patch-destinations with [not any? turtles-here]
   if target != nobody [
     face target
     move-to target]]
 ask patches [set whosNext -1]]
 

if movement = "straightFd1" [
;; A turtle moves to the patch directly ahead of it. If patch is not empty, the turtle stays put.
 ask turtles [
   let x who
   ask patch-ahead 1 [set whosNext x]
   let patch-destinations neighbors with [whosNext = x]
   let target one-of patch-destinations with [not any? turtles-here]
   if target != nobody [
     face target
     move-to target]]
 ask patches [set whosNext -1]]

end
;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;
to update-domain ; This procedure calculates the simulation's output variables.
    
   ; RELIABILITY &  CREATIVITY
  if use-evaluators? = true [
  if number-evaluators > 1 [
  if ticks > 2 [
    
   let jR []

   ask patches with [justMade = true] [
     set currentEvals (sort currentEvals)
     set jR fput (currentEvals) jR
   ]; ask patches
   
   ask domain [

     set justRated jR
     set justRated (map [prepare ?] justRated)
     
     
     let N (length justRated)
     let m (number-evaluators)

     
     set justRatedTable (map [? ^ 2] justRatedTable)


 
     let Nij2 (sum justRatedTable)

     set Nij2 (Nij2 - (N * m))
  
     set Nij2 (Nij2 / (N * m * (m - 1)))
  
     let P (Nij2)
     
     
     
     
     let p0 []
     foreach justRated [set p0 fput (extract-0 ?) p0]
     set p0 (sum p0)
     ;print "p0" print p0
     set p0 (p0 / (N * m))
     set p0 (p0 ^ 2)
     ;print "p0" print p0
     
     let p1 []
     foreach justRated [set p1 fput (extract-1 ?) p1]
     
    
    
     let c (p1)
     set c (map [? / number-evaluators] c)
     let a (sum c)
     let b (length c)
     set crea precision (a / b) 2
       
       
       
       
     set p1 (sum p1)
     ;print "p1" print p1
     set p1 (p1 / (N * m))
     set p1 (p1 ^ 2)
     ;print "p1" print p1

     let Pex (p0 + p1)
     
     
     ifelse P = 1
       [set rel 1]
       [let r (P - Pex)
        let s (1 - Pex)
        set rel precision (r / s) 2]
     
;     let r (1 + ((m - 1) * (p0 + p1)))
;     set r (N * m * r)
;     set r (Nij2 - r)
;     
;     let s (1 - p0 - p1)
;     ;print s
;     set s (N * m * (m - 1) * s)
     ;print s
     ;print ticks
     ;print r
     ;print s
     
     
;     let t []
;     ifelse s = 0 [set t 0][set t (r / s)] ; Two different conditions: 1) s = 0 => rel undefined. 2) r < 0 => rel negative.
;     set rel precision t 2
;     ;print rel print ""

]; ask domain
]; if ticks > ... 
]; if number-evaluators...
]; if use-evaluators?
   
   
   
   
   

   
   
   let sample [] ; Two helper local variables to update the domain.
   let pList  []
       
   let distCx [] ; These are just records of patchwork frequencies per subsample and tick.
   let distC1 []
   let distC2 []
   let distC3 []
   let distCAll []
   
   let rgbDomCx (rgbSpaceDom) ; These variables are just records of patchworks and their frequencies per subsample and per tick. The frequencies are set below.
   let rgbDomC1 (rgbSpaceDom) 
   let rgbDomC2 (rgbSpaceDom)
   let rgbDomC3 (rgbSpaceDom)
   let rgbDomCAll (rgbSpaceDom)
    
   let list_hXY [] ; List to collect frequencies to later calcualte hXY (interim variable for hX.Y).
   
   if ticks > 0 [ 
    
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Calculates rgbDomCx, distCx, hCx (ONLY patchworks by Cx)
    if any? creators with [label = "Cx"] [if any? patches with [madeBy = "Cx"] [
      set sample "Cx" ; Only patches with madeBy = Cx used for calcualtions.
      set pList (make-pList sample pList) ; To-report procedure "make-pList" below fills local list pList with madeBy=Cx patches' pDom variables.   
      set rgbDomCx (update-dom pList rgbDomCx) ; To-report procedure "update-dom" below updates frequency counters (items 1) in rgbDomCx according to pList. 
      foreach rgbDomCx [set distCx lput (item 1 ?) distCx] ; distCx is the "raw", absolute distribution of colors/products (w/o color category in nested lists) for creator type Cx.  
      foreach distCx [set list_hXY lput (?) list_hXY] ; Collects Cx patchwork frequencies to later calculate hXY.
      let copy_distCx (distCx)
      set copy_distCx (map [do-rfq ? copy_distCx] copy_distCx) 


      set-current-plot "Patchworks by Cx"
      clear-plot
      foreach copy_distCx [plot ?]
      
      set copy_distCx (map [h-part-one ?] copy_distCx) 
      set hCx (h-part-two copy_distCx)]] 

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Calculates rgbDomC1, distC1, hC1 (ONLY patchworks by C1)
    if any? creators with [label = "C1"] [if any? patches with [madeBy = "C1"] [
      set sample "C1" ; Only patches with madeBy = C1 used for calcualtions. 
      set pList (make-pList sample pList) ; To-report procedure "make-pList" below fills local list pList with madeBy=C1 patches' pDom variables. 
      set rgbDomC1 (update-dom pList rgbDomC1) ; To-report procedure "update-dom" below updates frequency counters (items 1) in rgbDomC1 according to pList.
      foreach rgbDomC1 [set distC1 lput (item 1 ?) distC1] ; distC1 is the "raw", absolute distribution of colors/products (w/o color category in nested lists) for creator type C1. 
      foreach distC1 [set list_hXY lput (?) list_hXY] ; Collects C1 patchwork frequencies to later calculate hXY.
      let copy_distC1 (distC1)
      set copy_distC1 (map [do-rfq ? copy_distC1] copy_distC1)
      
      set-current-plot "Patchworks by C1"
      clear-plot
      foreach copy_distC1 [plot ?]
      
      set copy_distC1 (map [h-part-one ?] copy_distC1) 
      set hC1 (h-part-two copy_distC1)]] 
  
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Calculates rgbDomC2, distC2, hC2 (ONLY patchworks by C2)
    if any? creators with [label = "C2"] [if any? patches with [madeBy = "C2"] [
    set sample "C2" ; Only patches with madeBy = C2 used for calcualtions.
    set pList (make-pList sample pList) ; To-report procedure "make-pList" below fills local list pList with madeBy=C2 patches' pDom variables. 
    set rgbDomC2 (update-dom pList rgbDomC2) ; To-report procedure "update-dom" below updates frequency counters (items 1) in rgbDomC2 according to pList.
    foreach rgbDomC2 [set distC2 lput (item 1 ?) distC2]  ; distC2 is the "raw", absolute distribution of colors/products (w/o color category in nested lists) for creator type C2. 
    foreach distC2 [set list_hXY lput (?) list_hXY] ; Collects C2 patchwork frequencies to later calculate hXY.
    let copy_distC2 (distC2)
    set copy_distC2 (map [do-rfq ? copy_distC2] copy_distC2)

    set-current-plot "Patchworks by C2"
    clear-plot
    foreach copy_distC2 [plot ?]
      
    set copy_distC2 (map [h-part-one ?] copy_distC2) 
    set hC2 (h-part-two copy_distC2)]] 
    
   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Calculates rgbDomC3, distC3, hC3 (ONLY patchworks by C3)
   if any? creators with [label = "C3"] [if any? patches with [madeBy = "C3"] [
     set sample "C3" ; Only patches with madeBy=C3 used for calcualtions.
     set pList (make-pList sample pList) ; To-report procedure "make-pList" below fills local list pList with madeBy=C3 patches' pDom variables. 
     set rgbDomC3 (update-dom pList rgbDomC3) ; To-report procedure "update-dom" below updates frequency counters (items 1) in rgbDomC3 according to pList.
     foreach rgbDomC3 [set distC3 lput (item 1 ?) distC3] ; distC3 is the "raw", absolute distribution of colors/products (w/o color category in nested lists) for creator type C3. 
     foreach distC3 [set list_hXY lput (?) list_hXY] ; Collects C3 patchwork frequencies to later calculate hXY.
     let copy_distC3 (distC3)
     set copy_distC3 (map [do-rfq ? copy_distC3] copy_distC3)
     
    set-current-plot "Patchworks by C3"
    clear-plot
    foreach copy_distC3 [plot ?]
     
     set copy_distC3 (map [h-part-one ?] copy_distC3) 
     set hC3 (h-part-two copy_distC3)]] 
    
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Calculates rgbDomCAll, distCAll, hCAll (ONLY patchworks by creators [not environment])
  if any? patches with [madeBy != "Env"] [
     set sample "CAll" ; Only patches with madeBy!=Env used for calcualtions.
     set pList (make-pList sample pList) ; To-report procedure "make-pList" below fills local list pList with madeBy!=Env patches' pDom variables. 
     set rgbDomCAll (update-dom pList rgbDomCAll) ; To-report procedure "update-dom" below updates frequency counters (items 1) in rgbDomCAll according to pList.
     foreach rgbDomCAll [set distCAll lput (item 1 ?) distCAll] ; distCAll is the "raw", absolute distribution of colors/products (w/o color category in nested lists) for ALL creators. 
     let copy_distCAll (distCAll)
     set copy_distCAll (map [do-rfq ? copy_distCAll] copy_distCAll)
     
     set-current-plot "Patchworks by all creators"
     clear-plot
     foreach copy_distCAll [plot ?]
     
     set copy_distCAll (map [h-part-one ?] copy_distCAll)  
     set hCAll (h-part-two copy_distCAll)

     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Calculates hY  
     set hY ((sum copy_distCAll) * (- (1 / ln 2)))] ; Uses variable copy_distCAll to calculate hY. copy_distCAll has color/product categories k = domSize.

   
   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Calculates hX
   ask domain [
     let list_hX []
     ifelse any? patches with [madeBy = "C3"][set list_hX fput (sum distC3) list_hX][set list_hX fput (0) list_hX] ; Enters sum of patchworks of each creator type into list.
     ifelse any? patches with [madeBy = "C2"][set list_hX fput (sum distC2) list_hX][set list_hX fput (0) list_hX] ; If no patchworks for a creator type exist, enters 0 into list.
     ifelse any? patches with [madeBy = "C1"][set list_hX fput (sum distC1) list_hX][set list_hX fput (0) list_hX]
     ifelse any? patches with [madeBy = "Cx"][set list_hX fput (sum distCx) list_hX][set list_hX fput (0) list_hX]
     set list_hX (map [do-rfq ? list_hX] list_hX) 
     set list_hX (map [h-part-one ? ] list_hX) 
     set hX ((sum list_hX) * (- (1 / ln 2))) 
  
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Calculates hXY
     set list_hXY (map [do-rfq ? list_hXY] list_hXY) 
     set list_hXY (map [h-part-one ?] list_hXY) 
     set hXY ((sum list_hXY) * (- (1 / ln 2)))] 
  
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Calculates tXY, hY.X, hX.Y 
    let tXY ((hX + hY) - hXY) ; Transinformation (mutual information)
    ifelse hX = 0
     [set hX.Y -0.1 ] ; If hX = 0, hXY is basically undefined. This happens when only one type of creator is in the world. Pseudo number -0.1 is used to express this.
     [set hX.Y (tXY / hX)] ; Transinformation quotient hX.Y 
       
    
    
    
    ; cScores of patches are set to reflect current status of domain. Each one obtains the cScore valid in the domain for its (domSize) category. Remember a patch's domSize category is indicated by its plabel.
    if use-evaluators? = true [
      
      let k []

      ask domain [
      
      set cScoreList (evalList) 
      set cScoreList (map [do-score ?] cScoreList)
      set k (cScoreList)
 
      set justRated []
      set justRatedTable []
     
    ] ; ask domain

      ask patches [  
        set justMade false
        set toDo false
        set PcScoreList (k) ; Patches receive current domain evaluation list, meaning they have list of cScores for patchwork (= domSize) categories.
        let x (plabel)
        let y (item x PcScoreList)
        set cScore (y)
        set currentEvals []
        ifelse hue = "warm" [][]
        ] ; ask patches 
      
      
      
       ] ; if use-evaluators... 
      
      
      do-plots
      
      
      
      ;set crea []
      
    
   ]

 
         
end

to-report prepare [smallList]
  let l1 []
  let l0 []
  set l1 (filter [? > 0] smallList)
  ifelse empty? l1 [set l1 0][set l1 (length l1)]
  set l0 (filter [? < 1] smallList)
  ifelse empty? l0 [set l0 0] [set l0 (length l0)]
  set justRatedTable fput (l1) justRatedTable
  set justRatedTable fput (l0) justRatedTable
  set smallList fput (l1) smallList
  set smallList fput (l0) smallList
  set smallList (sublist smallList 0 2)
  report smallList 
end

to-report extract-0 [xList]
  let zero (item 0 xList)
  report zero
end

to-report extract-1 [xList]
  let one (item 1 xList)
  report one
end


to-report make-pList [sample pList] ; Assessing patchworks currently in the domain.
  set pList []
  ifelse sample = "CAll" 
     [ask patches with [madeBy != "Env"][set pList fput (plabel) pList]]
     [ask patches with [madeBy = sample][set pList fput (plabel) pList]] ; Collects observations (plabel) only for (sub)sample patches.
  set pList (sort pList)
  report pList
end



to-report update-dom [pList dom] ; Updating frequencies of patchworks currently in the domain.
  while [length pList > 0]
  [let x (item 0 pList)
   set dom replace-item x dom (replace-item 1 (item x dom) ((item 1 (item x dom)) + 1)) ; In dom, replace item x's item 1 (frequency counter) with +1.
   set pList but-first pList]
  report dom
end

to-report do-rfq [number copiedList]
  set number (number / (sum copiedList))
  report number
end

to-report h-part-one [rf] ; If rf (relative frequency) greater 0, sets rf to (rf * (ln rf)), else rf remains 0.
  ifelse rf > 0
    [set rf (rf * (ln rf))]
    [set rf 0]
  report rf
end

; NOTES
; p * (ld p) = 
; - (p * (ln p / ln 2)) = 
; -(1 / ln 2) * (p * (ln p))
; By the way: ld x = ln x / ln 2

to-report h-part-two [aList] ; Calculates relative information measure. 
  set aList ((sum aList) * (- (1 / ln 2))) ; Absolute information.
  if domSize = 64 [set aList (aList / (log 64 2))] ; Relative information (divided by Hmax = ld number of categories).
  if domSize = 512 [set aList (aList / (log 512 2))] 
  if domSize = 4096 [set aList (aList / (log 4096 2))]
  report (precision aList 3)
end

to do-plots
  set-current-plot "Output measures"

  if show-hCAll? = true [
    set-current-plot-pen "hCAll"
    plot hCAll]

 
 if show-hX.Y? = true [
   set-current-plot-pen "hX.Y"
   if hX.Y >= 0 [plot hX.Y]] ; hX.Y is only plotted if it is defined (>= 0).
 
 if show-rel? = true [
   if use-evaluators? = true [
     if ticks > 2 [
       set-current-plot-pen "rel"
       plot rel
       set-current-plot-pen "crea"
       plot crea
   ]]] ; show-rel? ; use-evaluators? ; if ticks
 
 set-current-plot "Domain creativity scores"
    clear-plot
    if use-evaluators? = true 
      [ask domain [foreach cScoreList [plot ?]]]
end

;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;
to forget-some-info 
 ask creators [ ; Creators forget 3 pieces of info.
   set cR (forget-cInfo cR) ; Change cR according to procedure to-report forget-cInfo.
   set cG (forget-cInfo cG) 
   set cB (forget-cInfo cB) 
 ]

 if use-evaluators? = true [
 ask evaluators [ ; Evaluators forget 3 pieces of info.
   let z 3 
   while [z > 0] [
   set eMem (forget-eInfo eMem) ; Change eMem according to procedure to-report forget-eInfo.
   set z (z - 1)] ; As soon as z = 0, forgetting is terminated.
 ]
 ]
end
 
   to-report forget-cInfo [cList]
     let y []
     let x (random 256) ; Chooses number from 0-255.
     while [item 1 (item x cList) <= 0] [set x (random 256)] ; If item 1 (item x cList) is not larger 0, continues selecting x until so.
     set y ((item 1 (item x cList)) - 1) ; Sets frequency counter (item 1) of item x in cList minus 1.
     set cList replace-item x cList (replace-item 1 (item x cList) (y)) ; Replaces old item 1 with y.
     report (cList) ; Reports back cList.
   end
 
   to-report forget-eInfo [eList]
     let y[]
     let x (random domSize) ; Chooses number from 0-domSize.
     while [item 1 (item x eList) <= 0] [set x (random domSize)] ; If item 1 (item x eList) is not larger 0, continues selecting x until so.
     set y ((item 1 (item x eList)) - 1) ; Sets frequency counter (item 1) of item x in eList minus 1.
     set eList replace-item x eList (replace-item 1 (item x eList) (y)) ; Replaces old item 1 with y.
     report (eList)
   end
;;;;;;;;;;;;;;;;;;;;;;;;;




@#$#@#$#@
GRAPHICS-WINDOW
13
384
296
688
10
10
13.0
1
0
1
1
1
0
1
1
1
-10
10
-10
10
0
0
1
ticks

BUTTON
140
10
203
43
NIL
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

BUTTON
227
10
290
43
NIL
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL

TEXTBOX
23
10
130
41
CRESY-II
25
0.0
1

SLIDER
20
125
192
158
predefine-r
predefine-r
1
256
256
1
1
NIL
HORIZONTAL

SLIDER
19
164
191
197
predefine-g
predefine-g
1
256
256
1
1
NIL
HORIZONTAL

SLIDER
19
206
191
239
predefine-b
predefine-b
1
256
256
1
1
NIL
HORIZONTAL

TEXTBOX
23
75
173
97
Macrosystem
18
0.0
1

CHOOSER
596
393
734
438
domSize
domSize
64 512 4096
1

TEXTBOX
26
105
176
123
Substantial variables
12
0.0
1

TEXTBOX
595
373
745
391
Technical variable
12
0.0
1

TEXTBOX
200
77
363
99
Creator Microsystem 
18
0.0
1

INPUTBOX
206
126
299
186
number-creators
4
1
0
Number

CHOOSER
375
105
467
150
movement
movement
"any8" "allButBehind7" "ahead3" "straightFd1"
0

CHOOSER
471
104
566
149
info-rate
info-rate
"n4" "n8"
1

TEXTBOX
589
77
770
100
Evaluator Microsystem
18
0.0
1

SLIDER
265
287
442
320
imagination
imagination
0.00
0.05
0.05
0.00001
1
NIL
HORIZONTAL

INPUTBOX
206
206
263
266
Cx
3
1
0
Number

INPUTBOX
263
206
321
266
C1
0
1
0
Number

INPUTBOX
321
206
381
266
C2
0
1
0
Number

INPUTBOX
381
206
441
266
C3
1
1
0
Number

TEXTBOX
204
104
354
122
Substantial variables
12
0.0
1

TEXTBOX
418
68
536
98
Technical variables\nCreators & Evaluators
12
0.0
1

TEXTBOX
592
100
742
118
Substantial variables
12
0.0
1

TEXTBOX
207
192
244
210
WHITE
11
0.0
1

TEXTBOX
267
191
311
209
LT GREY
11
0.0
1

TEXTBOX
324
191
370
209
DK GREY
11
0.0
1

TEXTBOX
383
191
422
209
BLACK
11
0.0
1

INPUTBOX
595
120
697
180
number-evaluators
15
1
0
Number

INPUTBOX
595
203
650
263
En
5
1
0
Number

INPUTBOX
650
203
704
263
Ea
5
1
0
Number

INPUTBOX
704
203
756
263
Ena
5
1
0
Number

SLIDER
594
288
771
321
novelty-stringency
novelty-stringency
0
1
0.25
0.01
1
NIL
HORIZONTAL

TEXTBOX
621
187
771
205
ALL WEAR RED VESTS
11
0.0
1

TEXTBOX
265
268
448
286
Creator individual system variable
12
0.0
1

TEXTBOX
595
267
791
295
Evaluator individual system variables
12
0.0
1

SLIDER
595
329
773
362
appropriateness-stringency
appropriateness-stringency
0
1
0.75
0.01
1
NIL
HORIZONTAL

MONITOR
1477
99
1534
144
hCAll
hCAll
2
1
11

SWITCH
807
58
930
91
show-hCAll?
show-hCAll?
0
1
-1000

PLOT
807
99
1468
249
Output measures
ticks
see legend
0.0
100.0
0.0
1.0
true
true
PENS
"hCAll" 1.0 0 -13345367 true
"hX.Y" 1.0 0 -14835848 true
"rel" 1.0 0 -16777216 true
"crea" 1.0 0 -5825686 true

SWITCH
936
59
1056
92
show-hX.Y?
show-hX.Y?
0
1
-1000

MONITOR
1479
151
1535
196
hX.Y
hX.Y
2
1
11

PLOT
809
455
1474
605
Patchworks by all creators
patchwork (domSize categorization)
relative fq.
0.0
65.0
0.0
1.0
true
false
PENS
"default" 1.0 1 -16777216 true

TEXTBOX
812
615
1475
643
Depending on domSize, 64, 512 or 4096 different kinds of patchworks can emerge. Plot shows their relative frequency in current world. 
11
0.0
1

TEXTBOX
812
632
1485
658
Note: A frequency bar for the last value on the x axis is not shown in NetLogo. Therefore, to show frequencies for the last patchwork \"x\", the axis must at least range to \"x + 1\".
9
0.0
1

PLOT
809
264
1470
413
Domain creativity scores
patchwork (domSize categorization)
cScore
0.0
65.0
-1.0
1.0
true
false
PENS
"default" 1.0 1 -16777216 true

TEXTBOX
814
419
1470
447
By default, patchworks are (-1) if they have never been evaluated before. Otherwise evaluations range from 0-1. AND: Values are only shown if use-evaluators? = true.
11
0.0
1

SWITCH
1062
59
1171
92
show-rel?
show-rel?
0
1
-1000

SWITCH
603
38
747
71
use-evaluators?
use-evaluators?
0
1
-1000

INPUTBOX
129
314
194
374
tickstop
5
1
0
Number

SWITCH
15
339
119
372
tickstop?
tickstop?
1
1
-1000

TEXTBOX
1075
19
1343
41
OUTPUT DIAGNOSTICS
18
0.0
1

MONITOR
1480
202
1537
247
NIL
rel
2
1
11

TEXTBOX
1544
218
1617
249
Evaluator RELiability
11
0.0
1

TEXTBOX
1538
97
1637
125
Relative information h by All Creators
11
0.0
1

TEXTBOX
1540
152
1634
194
Mutual information h of creators (X) and patchworks (Y)
11
0.0
1

PLOT
808
661
1008
811
Patchworks by Cx
patchwork
Rel. fq.
0.0
65.0
0.0
1.0
true
false
PENS
"default" 1.0 0 -16777216 true

PLOT
1007
661
1207
811
Patchworks by C1
patchwork
Rel. fq.
0.0
65.0
0.0
1.0
true
false
PENS
"default" 1.0 0 -16777216 true

PLOT
1207
661
1407
811
Patchworks by C2
patchwork
Rel. fq.
0.0
65.0
0.0
1.0
true
false
PENS
"default" 1.0 0 -16777216 true

PLOT
1407
661
1607
811
Patchworks by C3
patchwork
Rel. fq.
0.0
65.0
0.0
1.0
true
false
PENS
"default" 1.0 0 -16777216 true

MONITOR
1342
837
1399
882
NIL
hX
3
1
11

MONITOR
1406
837
1463
882
NIL
hY
3
1
11

MONITOR
1471
837
1528
882
NIL
hXY
3
1
11

TEXTBOX
613
552
763
570
NIL
11
0.0
1

TEXTBOX
1164
845
1358
873
FYI: hX.Y = ((hX + hY) - hXY) / hX
11
0.0
1

SWITCH
1178
59
1302
92
show-crea?
show-crea?
0
1
-1000

MONITOR
1482
282
1538
327
NIL
crea
2
1
11

TEXTBOX
1546
249
1679
277
Only calculated if \nnumber-evaluators > 1
11
15.0
1

@#$#@#$#@
WHAT IS IT?
-----------
CRESY-II simulates creativity as an emergent phenomenon resulting from creative production and evaluation processes exhibited by autonomous agents. The model demonstrates the effects, in terms of emerging product domains, of creators and evaluators. The former act on the basis of behavioural variability, i.e. a theoretical continuum describing how differently (variable) an individual behaves or creates from time to time (Stokes, 1999, 2007). The latter act on the basis of varying levels of stringency regarding conventional evaluation criteria for creativity - novelty and appropriateness (Amabile & Mueller, 2007; Ward, Smith & Finke 1999). An abstract model, CRESY-II was designed for theoretical exploration and hypotheses generation. It is the second model in a series designed to describe a systems approach to creativity in terms of variation, selection and retention subprocesses (Csikszentmihalyi, 1988, 1999; Kahl, 2009, Rigney, 2001).

Programmed with NetLogo 4.1 (Wilensky, 1999), CRESY-I encompasses the follow-
ing entities: creators, patchworks, evaluators and the domain. Creators are agents
("turtles") characterized by a) the state variables defined in the globals (see Procedures Tab) and b) the Microsystem / Individual System input variables set in the Interface Tab. 

Patchworks abstractly represent objects creators produce, such as ideas, paintings, movements, or other cultural artefacts. Technically, patchworks are considered agents or spatial units ("patches"). They appear as colours characterized by rgb values. The production of patchworks becomes visible to the observer, because creators do not only make an rgb colour by combining three separately selected values chosen from their memories, they "paint" the colour on the patch they are currently standing on. See the state variables defined in the globals for patches.


Evaluators are turtles characterized by a) the state variables defined in the globals (see Procedures Tab) and b) the Microsystem / Individual System input variables set in the Interface Tab. Note that in CRESY-II the input variable domSize belongs to evaluators. They can, therefore, only perceive patchworks with a certain degree of differentiation, and this recognition is not as fine-tuned as that of creators. In evolutionary terms, they only perceive a patchwork’s phenotype, whereas creators are aware of patchworks’ genotypes (Chattoe, 1998).


The domain is a higher-level entity abstractly representing a symbolic, or informa-
tional, system (Csikszentmihalyi, 1988, 1999). It specifically constitutes the population of patchworks in the simulation at a current time step as well as over all time steps, and it is technically represented in NetLogo by a single, invisible agent (turtle) as well as a few variables (see globals in Procedures). Its purpose is to record information about the patchworks and calculate output variables at every time step. Theoretically, the domain is formed by variation and selection processes (Csikszentmihalyi, 1988, 1999; Kahl, 2009). 

HOW IT WORKS
------------
This section describes CRESY-II’s procedures or submodels. If
they function in same way as in CRESY-I, they are not re-explained here (they can be reread in the Info Tab of CRESY-I). The following main procedures are used in CRESY-II when the simulation "goes":

obtain-info
Creators and evaluators obtain information in the same way as in CRESY-I. The only difference is that evaluators save patches’ plabel variable, which indicates their domSize category. This does mean creators have more (memory) variables than evaluators, and at face value they receive more information. However, each memory variable - be it that of creators or evaluators - is updated with the same amount of information according to info-rate. So creators receive info-rate ∗ 3 pieces of information, whereas evaluators receive info-rate ∗ 1 pieces of information. Each memory variable (cR, cG, cB and eMem) receives info-rate pieces of information.

make-patchwork
Creators make patchworks in exactly the same manner as in CRESY-I. The only difference is that creators no longer place their patchworks on the patches they are currently standing on, but on one of the eight neighbouring patches with the lowest creativity score (cScore). This simple form of retention ensures that more favoured patchworks remain longer in the domain ("survival of the fittest enough"). 

rate-patchwork
Evaluators rate patchworks according to their perceived novelty and/or appropriate-
ness, and they can be one of three types: En (judges only novelty), Ea (judges
only appropriateness) or Ena (judges both). An evaluator’s judgement results in
one dichotomous creativity score (cScore) for a particular patch: 0 = not creative,
1 = creative. Evaluators judging patchworks based on their perceived novelty do
so according to the variable threshold novelty-stringency, and those judging appro-
priateness are influenced by the variable threshold appropriateness-stringency. Both
thresholds are set by the observer in NetLogo’s Interface Tab, so they are the same for all evaluators affected by them. Note that evaluator type Ena must judge a patchwork’s novelty as given (1) and its appropriateness as given (1) in order to rate the entire patchwork as creative (1). The observer can set how many evaluators of each type are desired by using input boxes in NetLogo’s Interface Tab.

move
Different movement strategies are available for creators and evaluators, and they can
be set by the modeller with a so-called chooser in NetLogo’s Interface Tab. The
strategies were already explained in CRESY-I's Info Tab.

forget-some-info
Creators and evaluators forget according to the same-named submodel in CRESY-I. Analogous to the way creators forget in CRESY-I, evaluators also forget three randomly selected pieces of information which are deleted from their memory eMem.

tick
NetLogo’s built-in time counter advances. 

update-domain
During this procedure all dependent variables and the interim variables used for their
calculation are updated. Additionally, patches’ cScores are updated to reflect the evaluation status of the domain.

THINGS TO NOTICE
----------------
The beige boxes in the Interface document the model's output. You can watch these things while a simulation runs. For instance:

The plots "Patchworks by all Creators", "Patchworks by Cx", "Patchworks by C1", "Patchworks by C2" and "Patchworks by C3" document the current frequencies of patchworks (colors according to domSize categorization) as a logarithmic function. You can watch their distributions change. 

You can observe the development of the output variables in the plot "Output measures". Note that you can select which and how many to observe by using the switches directly above the plot. The measure hCAll refers to the patchwork diversity produced by all creators. The measure hX.Y describes how well a creator type (X) can be guessed given a randomly selected patchwork (Y). hY.X describes the opposite. rel measures evaluators' reliability (Fleiss' kappa for binary data). crea measures the average creativity of the currently evaluated patchworks. All measures vary from 0 - 1. 

The plot "Domain creativity scores" relays the cumulative average creativity scores for all patchworks (classified according to domSize). It's a historical record. 

THINGS TO TRY
-------------
By using the green sliders, choosers and input boxes for the Macrosystem and Microsystems / Individual Systems, you can set up a world to observe and simulate. 

MACROSYSTEM: Define how many r, g and b values are available in the world to start by setting the predefine sliders. 

CREATOR MICROSYSTEM / INDIVIDUAL SYSTEM: Decide how many creators the world should have (number-creators). Set their types in the input boxes Cx, C1, C2, C3. Then decide how likely the creator types C1, C2 and C3 will create a color value they have never seen before (imagination). 

EVALUATOR MICROSYSTEM / INDIVIDUAL SYSTEM: Decide whether to use evaluators at all (use-evaluators?). If not, you will be using CRESY-I. If you do use evaluators (CRESY-II), decide how many the world should have (number-evaluators). Set their types in the input boxes (En, Ea, Ena). Don't forget to set how stringent they are in assessing a patchwork's novelty (novelty-stringency) and appropriateness (appropriateness-stringency). Set how many colors are actually perceived by the evaluators by setting domSize ("domain size"). 


You may also vary the amount of information creators and evaluators obtain (info-rate) as well as how they move (movement). 





EXTENDING THE MODEL
-------------------
In viewing this simulation model as a point of scientific departure, there are many possible destinations continuing research could head for. CRESY-II demonstrates a specific form of variation. It would be possible to conceive other forms of variation processes based on different views of what constitutes creative production. Besides combinatorial creativity, types such as exploratory and transformational creativity have been discussed (Boden, 1999). Moreover, a variety of more complex products beyond three-dimensional colours could be modelled and explored (see for instance Gabora, 1995; Picascia & Paolucci, 2010). 


CRESY-II could be extended by varying the selection process to reflect a more qualitative form of assessment. Also, different quantitative ways of combining novelty and appropriateness judgements could be simulated. Furthermore, direct social interaction between creators, evaluators and these two agent types could be added. This would obviously change the model's target. Phenomena such as social / support networks, empathy and leadership dynamics could then be incorporated as factors potentially relevant to shaping a domain's diversity and creativity.  



RELATED MODELS
--------------
CRESY-II and the following models resemble each other in some aspects:

Antonelli, C. and Ferraris, G. (2011). Innovation as an emerging system property: An agent-based simulation model. Journal of Artificial Societies and Social Simulation, 14 (2) 1. Retrieved April 11, 2011, from http://jasss.soc.surrey.ac.uk/14/2/1.html

Bryson, J. (2008). The role of modularity in stabilizing cultural evolution: Confor-
mity and innovation in an agent-based model. In A. Davis & J. Ludwig (Eds.),
Proceedings of the AAAI Fall Symposium on Adaptive Agents in Cultural Contexts
/ AACC ’08 (pp. 8–17). Menlo Park, CA: AAAI Press. Retrieved April 3, 2011, from                                 		www.cs.bath.ac.uk/~jjb/ftp/BrysonAAAI08-Conformity.pdf

Edmonds, B. (1999). Gossip, sexual recombination and the El Farol bar: Modelling the emergence of heterogenity. Journal of Artificial Societies and Social Simulation, 2 (3). Retrieved April 11, 2011, from http://jasss.soc.surrey.ac.uk/2/3/2.html

Gabora, L. (1995). Meme and variations: A computational model of cultural evo-
lution. In L. Nadel & D. Stein (Eds.), 1993 Lectures in Complex Systems (pp.
471–486). Boston: Addison Wesley. Retrieved April 3, 2011, from www.vub.ac.be/CLEA/liane/papers/mav.pdf

Gabora, L. (2008). EVOC: A computer model of cultural evolution. In V. Sloutsky,
B. Love, & R. McRae (Eds.), 30th Annual Meeting of the Cognitive Science
Society (pp. 1–6). North Salt Lake, UT: Sheridan Publishing. Retrieved April 3, 2011, from www.vub.ac.be/CLEA/liane/papers/evoc.pdf

Paolucci, M. & Picascia, S. (2010). Simulating cultural dynamics in peer production environment. In The QualityCommons: A workshop on collective quality representations (pp. 38–40). Surrey, UK: Centre for Research in Social Simulation, University of Surrey. Retrieved April 3, 2011, from http://cress.soc.surrey.ac.uk/web/events/qualitycommons-workshop


CREDITS
----------------------
We find that all creative work is collaborate in some manner. Therefore...

Thanks firstly to Hans Hansen for thinking, calculating and criticizing along. 

We greatly appreciate the valuable suggestions made by the following researchers regarding this model or its earlier versions: Erich H. Witte, Klaus Troitzsch, Nigel Gilbert, Iris Lorscheid, Nanda Wijermans, the SIMSOC[at]WORK group, Florian Felix Meyer, Mario Paolucci.

Many thanks to Seth Tisue, James Steiner, Nick Bennett and sanbalestrini from the NetLogo Users' Group for their fast and helpful replies to our posts as well as for their suggested pieces of code.

Last but definitely not least thanks to Uri Wilensky for NetLogo and the reusable code in models from the NetLogo Models Library!

REFERENCES
----------------------
Amabile, T. & Mueller, J. (2007). Psychometric approaches to the study of human creativity. In J. Zhou & C. Shalley (Eds.), Handbook of organizational creativity (pp. 33–64). New York: Lawrence Erlbaum Associates.


Boden, M. (1999). Computer models of creativity. In R. Sternberg (Ed.), Handbook
of creativity (pp. 351–372). Cambridge, UK: Cambridge University Press.

Chattoe, E. (1998). Just how (un)realistic are evolutionary algorithms as represen-
tations of social processes? Journal of Artificial Societies and Social Simulation,
1(3), 2. Retrieved July 3, 2011, from http://jasss.soc.surrey.ac.uk/1/3/2.html

Csikszentmihalyi, M. (1988). Society, culture, and person: A systems view of creativ-
ity. In R. Sternberg (Ed.), The nature of creativity. Contemporary psychological
perspectives (pp. 325–339). Cambridge, UK: Cambridge University Press.

Csikszentmihalyi, M. (1999). Implications of a systems perspective for the study of
creativity. In R. Sternberg (Ed.), Handbook of creativity (pp. 313–338). Cam-
bridge, UK: Cambridge University Press.

Gabora, L. (1995). Meme and variations: A computational model of cultural evo-
lution. In L. Nadel & D. Stein (Eds.), 1993 Lectures in Complex Systems (pp.
471–486). Boston: Addison Wesley.

Kahl, C. (2009). Modeling a social environment to investigate creativity: An agent-
based model. In E. Witte & C. Kahl (Eds.), Sozialpsychologie der Kreativität und
Innovation [Social psychology of creativity and innovation] (pp. 27–52). Lengerich,
Germany: Pabst Science Publishers.

Picascia, S. & Paolucci, M. (2010). Diffusion of culture and the "PageRank effect".
In A. Ernst & S. Kuhn (Eds.), Proceedings of the 3rd World Congress on So-
cial Simulation WCSS2010 (pp. 1–10; CD–ROM). Kassel, Germany: Center for
Environmental Systems Research, University of Kassel.

Rigney, D. (2001). The metaphorical society: An invitation to social theory. Lanham,
MD: Rowman & Littlefield.

Stokes, P. (1999). Learned variability levels: Implications for creativity. Creativity
Research Journal, 12(1), 37–45.

Stokes, P. (2007). Using constraints to generate and sustain novelty. Psychology of
Aesthetics, Creativity, and the Arts, 1(2), 107–113.

Ward, T., Smith, S., & Finke, R. (1999). Creative cognition. In R. Sternberg (Ed.), Handbook of creativity (pp. 189–212). Cambridge, UK: Cambridge University Press.


Wilensky, U. (1999). NetLogo. Evanston, IL: Center for Connected Learning and
Computer-Based Modeling, Northwestern University. Retrieved October 20, 2010,
from http://ccl.northwestern.edu/netlogo/

@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

person service
false
0
Polygon -7500403 true true 180 195 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285
Polygon -1 true false 120 90 105 90 60 195 90 210 120 150 120 195 180 195 180 150 210 210 240 195 195 90 180 90 165 105 150 165 135 105 120 90
Polygon -1 true false 123 90 149 141 177 90
Rectangle -7500403 true true 123 76 176 92
Circle -7500403 true true 110 5 80
Line -13345367 false 121 90 194 90
Line -16777216 false 148 143 150 196
Rectangle -16777216 true false 116 186 182 198
Circle -1 true false 152 143 9
Circle -1 true false 152 166 9
Rectangle -16777216 true false 179 164 183 186
Polygon -2674135 true false 180 90 195 90 183 160 180 195 150 195 150 135 180 90
Polygon -2674135 true false 120 90 105 90 114 161 120 195 150 195 150 135 120 90
Polygon -2674135 true false 155 91 128 77 128 101
Rectangle -16777216 true false 118 129 141 140
Polygon -2674135 true false 145 91 172 77 172 101

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
0
Rectangle -7500403 true true 151 225 180 285
Rectangle -7500403 true true 47 225 75 285
Rectangle -7500403 true true 15 75 210 225
Circle -7500403 true true 135 75 150
Circle -16777216 true false 165 76 116

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 4.1
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="Exp CII-1b-lo-lo-nov-01" repetitions="30" runMetricsEveryStep="true">
    <setup>if Ena = 15 [set number-evaluators 15]
setup</setup>
    <go>go
set cond 01
set evalStrategy "nov"</go>
    <timeLimit steps="6000"/>
    <metric>evalStrategy</metric>
    <metric>cond</metric>
    <metric>hCAll</metric>
    <metric>hX.Y</metric>
    <metric>rel</metric>
    <metric>crea</metric>
    <enumeratedValueSet variable="predefine-r">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-g">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-b">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-creators">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Cx">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C1">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C2">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C3">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="imagination">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="info-rate">
      <value value="&quot;n8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movement">
      <value value="&quot;any8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="use-evaluators?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="En">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ea">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ena">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="novelty-stringency">
      <value value="0.25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="appropriateness-stringency">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="domSize">
      <value value="512"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tickstop?">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Exp CII-1b-lo-lo-app-02" repetitions="30" runMetricsEveryStep="true">
    <setup>if Ena = 15 [set number-evaluators 15]
setup</setup>
    <go>go
set cond 02
set evalStrategy "app"</go>
    <timeLimit steps="6000"/>
    <metric>evalStrategy</metric>
    <metric>cond</metric>
    <metric>hCAll</metric>
    <metric>hX.Y</metric>
    <metric>rel</metric>
    <metric>crea</metric>
    <enumeratedValueSet variable="predefine-r">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-g">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-b">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-creators">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Cx">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C1">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C2">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C3">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="imagination">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="info-rate">
      <value value="&quot;n8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movement">
      <value value="&quot;any8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="use-evaluators?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="En">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ea">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ena">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="novelty-stringency">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="appropriateness-stringency">
      <value value="0.75"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="domSize">
      <value value="512"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tickstop?">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Exp CII-1b-lo-lo-cla-03" repetitions="30" runMetricsEveryStep="true">
    <setup>if Ena = 15 [set number-evaluators 15]
setup</setup>
    <go>go
set cond 03
set evalStrategy "cla"</go>
    <timeLimit steps="6000"/>
    <metric>evalStrategy</metric>
    <metric>cond</metric>
    <metric>hCAll</metric>
    <metric>hX.Y</metric>
    <metric>rel</metric>
    <metric>crea</metric>
    <enumeratedValueSet variable="predefine-r">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-g">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-b">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-creators">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Cx">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C1">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C2">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C3">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="imagination">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="info-rate">
      <value value="&quot;n8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movement">
      <value value="&quot;any8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="use-evaluators?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="En">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ea">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ena">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="novelty-stringency">
      <value value="0.25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="appropriateness-stringency">
      <value value="0.75"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="domSize">
      <value value="512"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tickstop?">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Exp CII-1b-lo-lo-equ-04" repetitions="30" runMetricsEveryStep="true">
    <setup>if Ena = 15 [set number-evaluators 15]
setup</setup>
    <go>go
set cond 04
set evalStrategy "equ"</go>
    <timeLimit steps="6000"/>
    <metric>evalStrategy</metric>
    <metric>cond</metric>
    <metric>hCAll</metric>
    <metric>hX.Y</metric>
    <metric>rel</metric>
    <metric>crea</metric>
    <enumeratedValueSet variable="predefine-r">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-g">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-b">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-creators">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Cx">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C1">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C2">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C3">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="imagination">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="info-rate">
      <value value="&quot;n8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movement">
      <value value="&quot;any8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="use-evaluators?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="En">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ea">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ena">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="novelty-stringency">
      <value value="0.5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="appropriateness-stringency">
      <value value="0.5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="domSize">
      <value value="512"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tickstop?">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Exp CII-1b-lo-lo-mix-05" repetitions="30" runMetricsEveryStep="true">
    <setup>set number-evaluators 15
setup</setup>
    <go>go
set cond 05
set evalStrategy "mix"</go>
    <timeLimit steps="6000"/>
    <metric>evalStrategy</metric>
    <metric>cond</metric>
    <metric>hCAll</metric>
    <metric>hX.Y</metric>
    <metric>rel</metric>
    <metric>crea</metric>
    <enumeratedValueSet variable="predefine-r">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-g">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-b">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-creators">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Cx">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C1">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C2">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C3">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="imagination">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="info-rate">
      <value value="&quot;n8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movement">
      <value value="&quot;any8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="use-evaluators?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="En">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ea">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ena">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="novelty-stringency">
      <value value="0.25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="appropriateness-stringency">
      <value value="0.75"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="domSize">
      <value value="512"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tickstop?">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Exp CII-1b-lo-hi-nov-06" repetitions="30" runMetricsEveryStep="true">
    <setup>set number-evaluators 15
setup</setup>
    <go>go
set cond 06
set evalStrategy "nov"</go>
    <timeLimit steps="6000"/>
    <metric>evalStrategy</metric>
    <metric>cond</metric>
    <metric>hCAll</metric>
    <metric>hX.Y</metric>
    <metric>rel</metric>
    <metric>crea</metric>
    <enumeratedValueSet variable="predefine-r">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-g">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-b">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-creators">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Cx">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C1">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C2">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C3">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="imagination">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="info-rate">
      <value value="&quot;n8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movement">
      <value value="&quot;any8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="use-evaluators?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="En">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ea">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ena">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="novelty-stringency">
      <value value="0.25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="appropriateness-stringency">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="domSize">
      <value value="512"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tickstop?">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Exp CII-1b-lo-hi-app-07" repetitions="30" runMetricsEveryStep="true">
    <setup>set number-evaluators 15
setup</setup>
    <go>go
set cond 07
set evalStrategy "app"</go>
    <timeLimit steps="6000"/>
    <metric>evalStrategy</metric>
    <metric>cond</metric>
    <metric>hCAll</metric>
    <metric>hX.Y</metric>
    <metric>rel</metric>
    <metric>crea</metric>
    <enumeratedValueSet variable="predefine-r">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-g">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-b">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-creators">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Cx">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C1">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C2">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C3">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="imagination">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="info-rate">
      <value value="&quot;n8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movement">
      <value value="&quot;any8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="use-evaluators?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="En">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ea">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ena">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="novelty-stringency">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="appropriateness-stringency">
      <value value="0.75"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="domSize">
      <value value="512"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tickstop?">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Exp CII-1b-lo-hi-cla-08" repetitions="30" runMetricsEveryStep="true">
    <setup>if Ena = 15 [set number-evaluators 15]
setup</setup>
    <go>go
set cond 08
set evalStrategy "cla"</go>
    <timeLimit steps="6000"/>
    <metric>evalStrategy</metric>
    <metric>cond</metric>
    <metric>hCAll</metric>
    <metric>hX.Y</metric>
    <metric>rel</metric>
    <metric>crea</metric>
    <enumeratedValueSet variable="predefine-r">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-g">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-b">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-creators">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Cx">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C1">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C2">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C3">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="imagination">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="info-rate">
      <value value="&quot;n8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movement">
      <value value="&quot;any8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="use-evaluators?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="En">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ea">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ena">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="novelty-stringency">
      <value value="0.25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="appropriateness-stringency">
      <value value="0.75"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="domSize">
      <value value="512"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tickstop?">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Exp CII-1b-lo-hi-equ-09" repetitions="30" runMetricsEveryStep="true">
    <setup>set number-evaluators 15
setup</setup>
    <go>go
set cond 09
set evalStrategy "equ"</go>
    <timeLimit steps="6000"/>
    <metric>evalStrategy</metric>
    <metric>cond</metric>
    <metric>hCAll</metric>
    <metric>hX.Y</metric>
    <metric>rel</metric>
    <metric>crea</metric>
    <enumeratedValueSet variable="predefine-r">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-g">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-b">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-creators">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Cx">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C1">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C2">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C3">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="imagination">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="info-rate">
      <value value="&quot;n8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movement">
      <value value="&quot;any8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="use-evaluators?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="En">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ea">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ena">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="novelty-stringency">
      <value value="0.5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="appropriateness-stringency">
      <value value="0.5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="domSize">
      <value value="512"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tickstop?">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Exp CII-1b-lo-hi-mix-10" repetitions="30" runMetricsEveryStep="true">
    <setup>set number-evaluators 15
setup</setup>
    <go>go
set cond 10
set evalStrategy "mix"</go>
    <timeLimit steps="6000"/>
    <metric>evalStrategy</metric>
    <metric>cond</metric>
    <metric>hCAll</metric>
    <metric>hX.Y</metric>
    <metric>rel</metric>
    <metric>crea</metric>
    <enumeratedValueSet variable="predefine-r">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-g">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-b">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-creators">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Cx">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C1">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C2">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C3">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="imagination">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="info-rate">
      <value value="&quot;n8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movement">
      <value value="&quot;any8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="use-evaluators?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="En">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ea">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ena">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="novelty-stringency">
      <value value="0.25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="appropriateness-stringency">
      <value value="0.75"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="domSize">
      <value value="512"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tickstop?">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Exp CII-1b-hi-lo-nov-11" repetitions="30" runMetricsEveryStep="true">
    <setup>set number-evaluators 15
setup</setup>
    <go>go
set cond 11
set evalStrategy "nov"</go>
    <timeLimit steps="6000"/>
    <metric>evalStrategy</metric>
    <metric>cond</metric>
    <metric>hCAll</metric>
    <metric>hX.Y</metric>
    <metric>rel</metric>
    <metric>crea</metric>
    <enumeratedValueSet variable="predefine-r">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-g">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-b">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-creators">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Cx">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C1">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C2">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C3">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="imagination">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="info-rate">
      <value value="&quot;n8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movement">
      <value value="&quot;any8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="use-evaluators?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="En">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ea">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ena">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="novelty-stringency">
      <value value="0.25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="appropriateness-stringency">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="domSize">
      <value value="512"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tickstop?">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Exp CII-1b-hi-lo-app-12" repetitions="30" runMetricsEveryStep="true">
    <setup>set number-evaluators 15
setup</setup>
    <go>go
set cond 12
set evalStrategy "app"</go>
    <timeLimit steps="6000"/>
    <metric>evalStrategy</metric>
    <metric>cond</metric>
    <metric>hCAll</metric>
    <metric>hX.Y</metric>
    <metric>rel</metric>
    <metric>crea</metric>
    <enumeratedValueSet variable="predefine-r">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-g">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-b">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-creators">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Cx">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C1">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C2">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C3">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="imagination">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="info-rate">
      <value value="&quot;n8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movement">
      <value value="&quot;any8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="use-evaluators?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="En">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ea">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ena">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="novelty-stringency">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="appropriateness-stringency">
      <value value="0.75"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="domSize">
      <value value="512"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tickstop?">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Exp CII-1b-hi-lo-cla-13" repetitions="30" runMetricsEveryStep="true">
    <setup>set number-evaluators 15
setup</setup>
    <go>go
set cond 13
set evalStrategy "cla"</go>
    <timeLimit steps="6000"/>
    <metric>evalStrategy</metric>
    <metric>cond</metric>
    <metric>hCAll</metric>
    <metric>hX.Y</metric>
    <metric>rel</metric>
    <metric>crea</metric>
    <enumeratedValueSet variable="predefine-r">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-g">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-b">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-creators">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Cx">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C1">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C2">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C3">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="imagination">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="info-rate">
      <value value="&quot;n8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movement">
      <value value="&quot;any8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="use-evaluators?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="En">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ea">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ena">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="novelty-stringency">
      <value value="0.25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="appropriateness-stringency">
      <value value="0.75"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="domSize">
      <value value="512"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tickstop?">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Exp CII-1b-hi-lo-equ-14" repetitions="30" runMetricsEveryStep="true">
    <setup>set number-evaluators 15
setup</setup>
    <go>go
set cond 14
set evalStrategy "equ"</go>
    <timeLimit steps="6000"/>
    <metric>evalStrategy</metric>
    <metric>cond</metric>
    <metric>hCAll</metric>
    <metric>hX.Y</metric>
    <metric>rel</metric>
    <metric>crea</metric>
    <enumeratedValueSet variable="predefine-r">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-g">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-b">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-creators">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Cx">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C1">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C2">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C3">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="imagination">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="info-rate">
      <value value="&quot;n8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movement">
      <value value="&quot;any8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="use-evaluators?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="En">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ea">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ena">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="novelty-stringency">
      <value value="0.5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="appropriateness-stringency">
      <value value="0.5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="domSize">
      <value value="512"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tickstop?">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Exp CII-1b-hi-lo-mix-15" repetitions="30" runMetricsEveryStep="true">
    <setup>set number-evaluators 15
setup</setup>
    <go>go
set cond 15
set evalStrategy "mix"</go>
    <timeLimit steps="6000"/>
    <metric>evalStrategy</metric>
    <metric>cond</metric>
    <metric>hCAll</metric>
    <metric>hX.Y</metric>
    <metric>rel</metric>
    <metric>crea</metric>
    <enumeratedValueSet variable="predefine-r">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-g">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-b">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-creators">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Cx">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C1">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C2">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C3">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="imagination">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="info-rate">
      <value value="&quot;n8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movement">
      <value value="&quot;any8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="use-evaluators?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="En">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ea">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ena">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="novelty-stringency">
      <value value="0.25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="appropriateness-stringency">
      <value value="0.75"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="domSize">
      <value value="512"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tickstop?">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Exp CII-1b-hi-hi-nov-16" repetitions="30" runMetricsEveryStep="true">
    <setup>set number-evaluators 15
setup</setup>
    <go>go
set cond 16
set evalStrategy "nov"</go>
    <timeLimit steps="6000"/>
    <metric>evalStrategy</metric>
    <metric>cond</metric>
    <metric>hCAll</metric>
    <metric>hX.Y</metric>
    <metric>rel</metric>
    <metric>crea</metric>
    <enumeratedValueSet variable="predefine-r">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-g">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-b">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-creators">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Cx">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C1">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C2">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C3">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="imagination">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="info-rate">
      <value value="&quot;n8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movement">
      <value value="&quot;any8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="use-evaluators?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="En">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ea">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ena">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="novelty-stringency">
      <value value="0.25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="appropriateness-stringency">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="domSize">
      <value value="512"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tickstop?">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Exp CII-1b-hi-hi-app-17" repetitions="30" runMetricsEveryStep="true">
    <setup>set number-evaluators 15
setup</setup>
    <go>go
set cond 17
set evalStrategy "app"</go>
    <timeLimit steps="6000"/>
    <metric>evalStrategy</metric>
    <metric>cond</metric>
    <metric>hCAll</metric>
    <metric>hX.Y</metric>
    <metric>rel</metric>
    <metric>crea</metric>
    <enumeratedValueSet variable="predefine-r">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-g">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-b">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-creators">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Cx">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C1">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C2">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C3">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="imagination">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="info-rate">
      <value value="&quot;n8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movement">
      <value value="&quot;any8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="use-evaluators?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="En">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ea">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ena">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="novelty-stringency">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="appropriateness-stringency">
      <value value="0.75"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="domSize">
      <value value="512"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tickstop?">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Exp CII-1b-hi-hi-cla-18" repetitions="30" runMetricsEveryStep="true">
    <setup>set number-evaluators 15
setup</setup>
    <go>go
set cond 18
set evalStrategy "cla"</go>
    <timeLimit steps="6000"/>
    <metric>evalStrategy</metric>
    <metric>cond</metric>
    <metric>hCAll</metric>
    <metric>hX.Y</metric>
    <metric>rel</metric>
    <metric>crea</metric>
    <enumeratedValueSet variable="predefine-r">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-g">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-b">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-creators">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Cx">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C1">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C2">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C3">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="imagination">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="info-rate">
      <value value="&quot;n8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movement">
      <value value="&quot;any8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="use-evaluators?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="En">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ea">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ena">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="novelty-stringency">
      <value value="0.25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="appropriateness-stringency">
      <value value="0.75"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="domSize">
      <value value="512"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tickstop?">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Exp CII-1b-hi-hi-equ-19" repetitions="30" runMetricsEveryStep="true">
    <setup>set number-evaluators 15
setup</setup>
    <go>go
set cond 19
set evalStrategy "equ"</go>
    <timeLimit steps="6000"/>
    <metric>evalStrategy</metric>
    <metric>cond</metric>
    <metric>hCAll</metric>
    <metric>hX.Y</metric>
    <metric>rel</metric>
    <metric>crea</metric>
    <enumeratedValueSet variable="predefine-r">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-g">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-b">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-creators">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Cx">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C1">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C2">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C3">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="imagination">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="info-rate">
      <value value="&quot;n8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movement">
      <value value="&quot;any8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="use-evaluators?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="En">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ea">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ena">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="novelty-stringency">
      <value value="0.5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="appropriateness-stringency">
      <value value="0.5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="domSize">
      <value value="512"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tickstop?">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Exp CII-1b-hi-hi-mix-20" repetitions="30" runMetricsEveryStep="true">
    <setup>set number-evaluators 15
setup</setup>
    <go>go
set cond 20
set evalStrategy "mix"</go>
    <timeLimit steps="6000"/>
    <metric>evalStrategy</metric>
    <metric>cond</metric>
    <metric>hCAll</metric>
    <metric>hX.Y</metric>
    <metric>rel</metric>
    <metric>crea</metric>
    <enumeratedValueSet variable="predefine-r">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-g">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="predefine-b">
      <value value="256"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number-creators">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Cx">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C1">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C2">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="C3">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="imagination">
      <value value="0.05"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="info-rate">
      <value value="&quot;n8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movement">
      <value value="&quot;any8&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="use-evaluators?">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="En">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ea">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Ena">
      <value value="5"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="novelty-stringency">
      <value value="0.25"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="appropriateness-stringency">
      <value value="0.75"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="domSize">
      <value value="512"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="tickstop?">
      <value value="false"/>
    </enumeratedValueSet>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 1.0 0.0
0.0 1 1.0 0.0
0.2 0 1.0 0.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
